-- Lulu88520
-- Script pour la sous soleuse Agrisem Combiplow 36 de Alexandre4555
-- @date  27/08/16
-- https://www.facebook.com/paulo5090r/
--
-- FS17 : Lulu88520 27/12/16

COMBIPLOW36 = {};

function COMBIPLOW36.prerequisitesPresent(specializations)
	  return true;
end;

function COMBIPLOW36:load(savegame)	
	self.toggleSupport = SpecializationUtil.callSpecializationsFunction("toggleSupport");  
	self.manualSupportAnimation = getXMLString(self.xmlFile, "vehicle.manualSupport#animationName");
	self.supportRangeIndex = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.manualSupport#rangeIndex"));
	self.isInRangeSupport = false;
	self.isSupportDown = true;
	
	self.playerInRangeDentG = false;	
	self.playerInRangeDentD = false;

	self.rangeDentG = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.rangeDentG#index"));	
	self.rangeDentD = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.rangeDentD#index"));	
end;

function COMBIPLOW36:delete()
end;

function COMBIPLOW36:readStream(streamId, connection)
 local isSupportDown = streamReadBool(streamId);
	self:toggleSupport(isSupportDown, true); 
	
end;

function COMBIPLOW36:writeStream(streamId, connection)
streamWriteBool(streamId, self.isSupportDown); 

end;

function COMBIPLOW36:mouseEvent(posX, posY, isDown, isUp, button)
end;

function COMBIPLOW36:keyEvent(unicode, sym, modifier, isDown) 
end;

function COMBIPLOW36:update(dt)
 if self:getIsActive() then		
		if self.isClient and self:getIsActiveForInput(false) and not self:hasInputConflictWithSelection() then
			-- Show warning about the support being down
			if self.isSupportDown then				
				g_currentMission:showBlinkingWarning(g_i18n:getText("BJR_SUPPORT_WARNING"), 7000);
			end;
		end;
	end;
         if self.supportRangeIndex then
		-- Manage key events for inrange support --
		if self.isInRangeSupport then
			if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
				if self.isSupportDown then
					self:toggleSupport(false);
				else
					self:toggleSupport(true);
				end;
			end;
			-- Display key when in range --
			if self.isSupportDown then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BJR_RAISE_SUPPORT")), InputBinding.IMPLEMENT_EXTRA2);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BJR_LOWER_SUPPORT")), InputBinding.IMPLEMENT_EXTRA2);
			end;
		end;
	end;
	
    if self.isClient and self.playerInRangeDentG then		
		local isKeyEvent = false;	
			if InputBinding.isPressed(InputBinding.IMPLEMENT_EXTRA) then
				self:setAnimationTime(1, self.animationParts[1].currentPosition+(self.animationParts[1].offSet*(dt/10)));
				isKeyEvent = true;
			elseif InputBinding.isPressed(InputBinding.LOWER_IMPLEMENT) then
				self:setAnimationTime(1, self.animationParts[1].currentPosition-(self.animationParts[1].offSet*(dt/10)));
				isKeyEvent = true;
			end;
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("SORTIR_DENT")), InputBinding.IMPLEMENT_EXTRA);
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RENTRER_DENT")), InputBinding.LOWER_IMPLEMENT);				
	end;  

	if self.isClient and self.playerInRangeDentD then		
		local isKeyEvent = false;	
			if InputBinding.isPressed(InputBinding.IMPLEMENT_EXTRA) then
				self:setAnimationTime(2, self.animationParts[2].currentPosition+(self.animationParts[1].offSet*(dt/10)));
				isKeyEvent = true;
			elseif InputBinding.isPressed(InputBinding.LOWER_IMPLEMENT) then
				self:setAnimationTime(2, self.animationParts[2].currentPosition-(self.animationParts[1].offSet*(dt/10)));
				isKeyEvent = true;
			end;
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("SORTIR_DENT")), InputBinding.IMPLEMENT_EXTRA);
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("RENTRER_DENT")), InputBinding.LOWER_IMPLEMENT);				
	end;   

	
end;

function COMBIPLOW36:updateTick(dt) 
 if self.supportRangeIndex then
		if g_currentMission.player ~= nil then
			-- Getting the distance between the player and the support
			local nearestDistance = 2.5; --max distance allowed
			local px, py, pz = getWorldTranslation(self.supportRangeIndex);
			local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			if distance < nearestDistance then
				self.isInRangeSupport = true;
			else
				self.isInRangeSupport = false;
			end;
		end;
	else
		self.isInRangeSupport = false;
	end;
	
	if g_currentMission.player ~= nil and self.isClient then
		local nearestDistance = 2.0;
		local px, py, pz = getWorldTranslation(self.rangeDentG);
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.playerInRangeDentG = true;
		else
			self.playerInRangeDentG = false;
		end;
	end;
	
	if g_currentMission.player ~= nil and self.isClient then
		local nearestDistance = 2.0;
		local px, py, pz = getWorldTranslation(self.rangeDentD);
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.playerInRangeDentD = true;
		else
			self.playerInRangeDentD = false;
		end;
	end;
end;

function COMBIPLOW36:postLoad(savegame)
	if savegame ~= nil and not savegame.resetVehicles then
	local isSupportDown = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key .. "#isSupportDown"), false);
	self:toggleSupport(isSupportDown);		
   end;
end;

function COMBIPLOW36:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'isSupportDown="' .. tostring(self.isSupportDown) .. '"';
    return attributes, nil;
end;

function COMBIPLOW36:toggleSupport(isSupportDown, noEventSend)
	ToggleSupportEvent.sendEvent(self, isSupportDown, noEventSend);	
	
	if not isSupportDown then
		if self.manualSupportAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualSupportAnimation, -1, nil, true);
		end;
	else
		if self.manualSupportAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualSupportAnimation, 1, nil, true);
		end;
	end;
	
	self.isSupportDown = isSupportDown;
end;
  
function COMBIPLOW36:onDetach()
end;

function COMBIPLOW36:onAttach()
end;

function COMBIPLOW36:draw() 
	
end;

-- Support event

ToggleSupportEvent = {};
ToggleSupportEvent_mt = Class(ToggleSupportEvent, Event);

InitEventClass(ToggleSupportEvent, "ToggleSupportEvent");

function ToggleSupportEvent:emptyNew()
    local self = Event:new(ToggleSupportEvent_mt);
    return self;
end;

function ToggleSupportEvent:new(object, isSupportDown)
    local self = ToggleSupportEvent:emptyNew()
    self.object = object;
	self.isSupportDown = isSupportDown;
    return self;
end;

function ToggleSupportEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.isSupportDown = streamReadBool(streamId);
    self:run(connection);
end;

function ToggleSupportEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));	
	streamWriteBool(streamId, self.isSupportDown);
end;

function ToggleSupportEvent:run(connection)
	self.object:toggleSupport(self.isSupportDown, true);
end;

function ToggleSupportEvent.sendEvent(object, isSupportDown, noEventSend)
	
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(ToggleSupportEvent:new(object, isSupportDown), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(ToggleSupportEvent:new(object, isSupportDown));
		end;
	end;
end;